From e9a7c8d7b6f3aa32ed8363ce2940ff10b78ea617 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Thu, 6 Feb 2020 15:30:19 +0100
Subject: [PATCH] =?UTF-8?q?new=20theme:=20r=C3=A9gion=20r=C3=A9union=20(#3?=
 =?UTF-8?q?9600)?=
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

---
 static/region-reunion/_custom.scss            | 205 ++++++++++++++++++
 static/region-reunion/_vars.scss              |  72 ++++++
 static/region-reunion/config.json             |   7 +
 .../img/logo-regionreunion-bleu.svg           |   3 +
 static/region-reunion/img/menu_top_fond.png   | Bin 0 -> 5516 bytes
 static/region-reunion/style.scss              |   6 +
 6 files changed, 293 insertions(+)
 create mode 100644 static/region-reunion/_custom.scss
 create mode 100644 static/region-reunion/_vars.scss
 create mode 100644 static/region-reunion/config.json
 create mode 100644 static/region-reunion/img/logo-regionreunion-bleu.svg
 create mode 100644 static/region-reunion/img/menu_top_fond.png
 create mode 100644 static/region-reunion/style.scss

diff --git a/static/region-reunion/_custom.scss b/static/region-reunion/_custom.scss
new file mode 100644
index 00000000..3b93e055
--- /dev/null
+++ b/static/region-reunion/_custom.scss
@@ -0,0 +1,205 @@
+%cancel-button {
+	@extend %button;
+	background-color: white;
+	border-color: $cyan;
+	color: $cyan;
+	&:hover {
+		background-color: white;
+		border-color: $primary-color;
+		color: $primary-color;
+	}
+}
+
+* {
+	box-sizing: border-box;
+	&::before, &::after {
+		box-sizing: inherit;
+	}
+}
+// HEADER
+#header-wrapper {
+	background: url(img/menu_top_fond.png) no-repeat top right;
+	border-bottom: 3px solid $primary-color;
+}
+
+#logo {
+	padding: 15px;
+	a {
+		color: $cyan;
+		$logo-height: 75px;
+		display: block;
+		font-weight: bold;
+		font-size: 18px;
+		padding-top: $logo-height + 5;
+		background: url(img/logo-regionreunion-bleu.svg) no-repeat;
+		background-size: auto $logo-height;
+
+		@media (min-width: $mobile-limit + 1) {
+			padding-left: 150px;
+			padding-top: 60px;
+			font-size: 24px;
+			line-height: 20px;
+			background-size: contain;
+		}
+
+		&::before {
+			content: "#";
+			color: $primary-color;
+			font-weight: bold;
+		}
+	}
+}
+#toplinks {
+	border: none;
+	box-shadow: none;
+}
+// NAV
+.gru-nav-wrapper {
+	@media (max-width: $nav-mobile-limit) {
+		margin-top: -$nav-menu-side - 15px;
+	}
+}
+div.gru-nav > ul  {
+	font-size: .85em;
+	margin: 0;
+	> li a {
+		font-weight: normal;
+		text-transform: uppercase;
+	}
+	// submenu
+	ul a {
+		&:hover {
+			background-color: white;
+			color: $font-color;
+		}
+	}
+}
+// burger btn
+div.gru-nav .gru-nav-button {
+	border: 1px solid $primary-color;
+	&.toggled {
+		background-color: $primary-color;
+		.icon-bar {
+			border-color: white;
+		}
+	}
+}
+body.has-picture nav::after {
+	position: static;
+}
+
+// PWA nav
+.pwa-navigation {
+	background-color: transparent;
+	text-transform: uppercase;
+	div > ul li {
+		border: 1px solid transparent;
+		background-color: $nav-mobile-bottom-bar-background;
+		background-clip: padding-box;
+		a {
+			background-position: 50% 5px;
+			background-size: auto 25px;
+			span {
+				display: flex;
+				justify-content: center;
+				align-items: center;
+			}
+		}
+	}
+}
+
+// MAIN
+main {
+	background-image:
+		linear-gradient(178deg, transparent 700px, white 701px),
+		linear-gradient(173deg, $xlight-gray 350px, $light-gray 351px)
+	;
+}
+
+// White bloc with shadow
+div#main-content-wrapper {
+	background-color: white;
+	margin-top: 40px;
+	padding-top: 1rem;
+	padding-bottom: 1rem;
+	box-shadow: 0 0px 30px 10px #ccc;
+	z-index: 0;
+
+	@media (min-width: $mobile-limit + 1) {
+		margin-top: 120px;
+		padding-left: 1rem;
+		padding-right: 1rem;
+	}
+}
+main {
+	&::after {
+		content: "";
+		display: block;
+		background-color: white;
+		height: 50px;
+		position: relative;
+		box-shadow: 0 0px 30px 20px white;
+	}
+}
+
+// CELLS
+// more link
+div.wcsformsofcategorycell ul li.more-items {
+	width: 1.5em;
+	height: 1.5em;
+	margin: auto;
+	font-size: 1.2em;
+	background-color: $orange;
+	display: flex;
+	transform: rotate(45deg);
+	a {
+		color: white;
+		font-weight: bold;
+		padding: 0;
+		display: block;
+		border: none;
+		margin: auto;
+		transform: rotate(-45deg);
+	}
+
+	&:hover {
+		background-color: $primary-color;
+		a {
+			background-color: transparent;
+		}
+	}
+}
+
+div.wcs-form-cell a {
+	@extend .pk-button;
+	display: block;
+}
+
+// WCS
+div#rub_service h2 {
+	font-size: 2rem;
+	color: $primary-color;
+}
+
+// FOOTER
+div#footer {
+	font-size: .9em;
+	img {
+		max-width: 100%;
+		height: auto;
+	}
+	// inclined top footer
+	@media (min-width: $width) {
+		position: relative;
+		margin-top: 60px;
+		&::before {
+			position: absolute;
+			bottom: 100%;
+			left: 0;
+			content: "";
+			display: block;
+			border-top: 60px solid transparent;
+			border-right: $width solid $footer-background;
+		}
+	}
+}
\ No newline at end of file
diff --git a/static/region-reunion/_vars.scss b/static/region-reunion/_vars.scss
new file mode 100644
index 00000000..1c049e06
--- /dev/null
+++ b/static/region-reunion/_vars.scss
@@ -0,0 +1,72 @@
+// Colors
+$dark-blue: #00579e;
+$pale-blue: #d6e0e8;
+$cyan: #00b1e6;
+$orange: #e56611;
+$green: #74bd04;
+$pink: #c7017f;
+$xlight-gray: #f5f3f1;
+$light-gray: #efece7;
+$gray: #c7bca9;
+$desaturate-orange: #a9987b;
+
+// Core Vars
+$mobile-limit: 960px;
+$width: 1160px;
+$primary-color: $dark-blue;
+$link-color: $primary-color;
+$font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
+$footer-background: $light-gray;
+$footer-full-width-background: false;
+$footer-color: #000;
+
+$nav-border-color: none;
+$nav-menu-color: white;
+$nav-active-color: $primary-color;
+$nav-item-selected-background: transparent;
+$nav-item-selected-color: $primary-color;
+$nav-item-hover-color: white;
+$nav-item-hover-background: $primary-color;
+$nav-submenu-background: $primary-color;
+
+$nav-mobile-menu-background: $primary-color;
+$nav-mobile-menu-item-color: white;
+$nav-menu-side: 40px;
+$nav-button-background: white;
+$nav-button-color: $primary-color;
+$nav-mobile-menu-item-hover-background: white;
+$nav-mobile-menu-item-hover-color: $primary-color;
+
+$nav-mobile-bottom-bar-background: $cyan;
+$nav-mobile-bottom-bar-color: white;
+
+$cell-border: 1px solid $light-gray;
+$cell-entry-hover-color: $primary-color;
+$cell-entry-hover-background: $pale-blue;
+$cell-entry-hover-color: black;
+$cell-entry-border-color: white;
+$cell-background: $xlight-gray;
+$cell-image-padding: 0;
+
+$title-font-size: 1.4rem;
+$title-border-bottom: $cell-border;
+$title-padding: .5em 0;
+$title-color: $cyan;
+$title-weight: bold;
+
+$wcs-step-border-bottom: none;
+$wcs-step-background: $xlight-gray;
+$wcs-step-color: $desaturate-orange;
+
+$button-color: white;
+$button-background: $cyan;
+$button-hover-background: $primary-color;
+
+$buttons-order: previous, cancel, submit;
+$buttons-alignment: space-around;
+
+$widget-border: 1px solid $gray;
+$widget-focus-border: 1px solid $primary-color;
+$widget-focus-color: $primary-color;
+
+// $widget-border: 2px solid $light-gray;
\ No newline at end of file
diff --git a/static/region-reunion/config.json b/static/region-reunion/config.json
new file mode 100644
index 00000000..ff80639b
--- /dev/null
+++ b/static/region-reunion/config.json
@@ -0,0 +1,7 @@
+{
+  "label": "Région Réunion",
+  "variables": {
+    "pwa_display": "standalone",
+    "theme_color": "#00579e"
+  }
+}
diff --git a/static/region-reunion/img/logo-regionreunion-bleu.svg b/static/region-reunion/img/logo-regionreunion-bleu.svg
new file mode 100644
index 00000000..3a0a0e5a
--- /dev/null
+++ b/static/region-reunion/img/logo-regionreunion-bleu.svg
@@ -0,0 +1,3 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg width="130" height="85" version="1.1" viewBox="0 0 130 85" xml:space="preserve" xmlns="http://www.w3.org/2000/svg" xmlns:cc="http://creativecommons.org/ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"><metadata><rdf:RDF><cc:Work rdf:about=""><dc:format>image/svg+xml</dc:format><dc:type rdf:resource="http://purl.org/dc/dcmitype/StillImage"/><dc:title/></cc:Work></rdf:RDF></metadata><defs><clipPath id="clipPath61"><path d="M 0,794.835 H 614.835 V 0 H 0 Z"/></clipPath></defs><g transform="matrix(1.3333 0 0 -1.3333 0 85)"><g transform="translate(-193.18 -460.18)"><g transform="matrix(.70285 0 0 .70285 57.404 136.89)"><g clip-path="url(#clipPath61)"><g transform="translate(198.29 482.61)"><path d="M 0,0 C 0,0 92.68,52.439 94.318,58.879 99.24,34.454 119.179,21.723 119.179,21.723 136.616,21.271 0,0 0,0" fill="#005ca9"/></g><g transform="translate(225.54 492.88)"><path d="m0 0c8.258 0.784 16.516 1.569 24.774 2.353-18.029-5.291-36.058-10.582-54.086-15.873 45.39 7.929 90.744 11.349 135.65 10.228" fill="none" stroke="#1d1d1b" stroke-miterlimit="10" stroke-width="1.5"/></g><g transform="translate(313.28 508.39)"><path d="m0 0c-10.7 7.926-18.242 20.001-20.671 33.094-30.415-23.044-63.034-43.179-97.265-60.041" fill="none" stroke="#1d1d1b" stroke-miterlimit="10" stroke-width="2"/></g><g transform="translate(199.53 489.94)"><path d="m0 0c34.233 16.929 66.789 37.025 97.266 60.041l-2.898-0.777c2.669-13.277 9.91-24.87 20.67-33.093 0.499-0.382 2.428 1.136 2.898 0.776-10.76 8.224-18.001 19.817-20.67 33.094 0.014-0.073-2.654-0.592-2.898-0.777-30.476-23.015-63.032-43.112-97.266-60.04 0.875 0.432 2.016 0.34 2.898 0.776" fill="#1d1d1b"/></g></g></g><g transform="matrix(.70285 0 0 -.70285 57.404 136.89)" fill="#1d1d1b" aria-label="#"><path d="m201.35-468.94h-2.672l-0.77129 3.0668h2.6904zm-1.3773-5.2246-0.95494 3.8106h2.6812l0.96412-3.8106h1.4691l-0.94576 3.8106h2.8648v1.414h-3.2229l-0.75293 3.0668h2.9199v1.4049h-3.278l-0.95493 3.8014h-1.4691l0.94576-3.8014h-2.6904l-0.94576 3.8014h-1.4783l0.95493-3.8014h-2.8924v-1.4049h3.2321l0.7713-3.0668h-2.9566v-1.414h3.3147l0.93657-3.8106z" stroke-width=".99999"/></g><g transform="matrix(.70285 0 0 -.70285 202.67 461.72)" fill="#1d1d1b" aria-label="RÉGIONRÉUNION"><path d="m6.6235-5.1006q0.47363 0.1603 0.91811 0.68494 0.45177 0.52463 0.90354 1.4427l1.4937 2.9729h-1.5812l-1.3917-2.7908q-0.53921-1.093-1.0493-1.45-0.50277-0.35704-1.3772-0.35704h-1.603v4.5978h-1.4719v-10.879h3.3227q1.8654 0 2.7835 0.77966 0.91811 0.77966 0.91811 2.3536 0 1.0274-0.48091 1.7051-0.47363 0.67765-1.3844 0.93997zm-3.687-4.5687v3.8619h1.8508q1.0638 0 1.603-0.4882 0.54649-0.49549 0.54649-1.45t-0.54649-1.4355q-0.53921-0.4882-1.603-0.4882z"/><path d="m10.582-10.879h6.8785v1.2387h-5.4066v3.2207h5.1808v1.2387h-5.1808v3.942h5.5378v1.2387h-7.0097zm3.8182-2.9583h1.348l-1.6613 1.9237h-1.1148z"/><path d="m27.118-1.552v-2.9219h-2.4046v-1.2096h3.8619v4.6707q-0.85253 0.60479-1.8799 0.91811-1.0274 0.30604-2.1933 0.30604-2.5503 0-3.993-1.4865-1.4355-1.4937-1.4355-4.1533 0-2.6669 1.4355-4.1533 1.4427-1.4937 3.993-1.4937 1.0638 0 2.0184 0.26232 0.96183 0.26232 1.7706 0.77238v1.5666q-0.8161-0.69222-1.7342-1.042t-1.9309-0.34976q-1.9965 0-3.0021 1.1148-0.99826 1.1148-0.99826 3.3227 0 2.2005 0.99826 3.3154 1.0055 1.1148 3.0021 1.1148 0.77966 0 1.3917-0.13116 0.61207-0.13844 1.1003-0.42262z"/><path d="m31.31-10.879h1.4719v10.879h-1.4719z"/><path d="m39.875-9.8806q-1.603 0-2.5503 1.195-0.93997 1.195-0.93997 3.2571 0 2.0548 0.93997 3.2498 0.94726 1.195 2.5503 1.195t2.5357-1.195q0.93997-1.195 0.93997-3.2498 0-2.0621-0.93997-3.2571-0.93268-1.195-2.5357-1.195zm0-1.195q2.288 0 3.6579 1.5375 1.3699 1.5302 1.3699 4.1096 0 2.5722-1.3699 4.1096-1.3699 1.5302-3.6579 1.5302-2.2953 0-3.6724-1.5302-1.3699-1.5302-1.3699-4.1096t1.3699-4.1096q1.3772-1.5375 3.6724-1.5375z"/><path d="m47.875-10.879h1.9819l4.8237 9.1009v-9.1009h1.4282v10.879h-1.9819l-4.8237-9.1009v9.1009h-1.4282z"/><path d="m64.912-5.1006q0.47363 0.1603 0.91811 0.68494 0.45177 0.52463 0.90354 1.4427l1.4937 2.9729h-1.5812l-1.3917-2.7908q-0.53921-1.093-1.0493-1.45-0.50277-0.35704-1.3772-0.35704h-1.603v4.5978h-1.4719v-10.879h3.3227q1.8654 0 2.7835 0.77966 0.91811 0.77966 0.91811 2.3536 0 1.0274-0.48091 1.7051-0.47363 0.67765-1.3844 0.93997zm-3.687-4.5687v3.8619h1.8508q1.0638 0 1.603-0.4882 0.54649-0.49549 0.54649-1.45t-0.54649-1.4355q-0.53921-0.4882-1.603-0.4882z"/><path d="m68.871-10.879h6.8785v1.2387h-5.4066v3.2207h5.1808v1.2387h-5.1808v3.942h5.5378v1.2387h-7.0097zm3.8182-2.9583h1.348l-1.6613 1.9237h-1.1148z"/><path d="m77.822-10.879h1.4792v6.6089q0 1.7488 0.63393 2.5212 0.63393 0.76509 2.0548 0.76509 1.4136 0 2.0475-0.76509 0.63393-0.77238 0.63393-2.5212v-6.6089h1.4792v6.7911q0 2.1277-1.0566 3.2134-1.0493 1.0857-3.1041 1.0857-2.0621 0-3.1187-1.0857-1.0493-1.0857-1.0493-3.2134z"/><path d="m88.495-10.879h1.9819l4.8237 9.1009v-9.1009h1.4282v10.879h-1.9819l-4.8237-9.1009v9.1009h-1.4282z"/><path d="m100.37-10.879h1.4719v10.879h-1.4719z"/><path d="m108.94-9.8806q-1.603 0-2.5503 1.195-0.93997 1.195-0.93997 3.2571 0 2.0548 0.93997 3.2498 0.94726 1.195 2.5503 1.195 1.603 0 2.5357-1.195 0.93997-1.195 0.93997-3.2498 0-2.0621-0.93997-3.2571-0.93268-1.195-2.5357-1.195zm0-1.195q2.288 0 3.6579 1.5375 1.3699 1.5302 1.3699 4.1096 0 2.5722-1.3699 4.1096-1.3699 1.5302-3.6579 1.5302-2.2953 0-3.6724-1.5302-1.3699-1.5302-1.3699-4.1096t1.3699-4.1096q1.3772-1.5375 3.6724-1.5375z"/><path d="m116.94-10.879h1.982l4.8237 9.1009v-9.1009h1.4282v10.879h-1.9819l-4.8237-9.1009v9.1009h-1.4282z"/></g></g></g></svg>
diff --git a/static/region-reunion/img/menu_top_fond.png b/static/region-reunion/img/menu_top_fond.png
new file mode 100644
index 0000000000000000000000000000000000000000..33700e3f6e02145ee24b7aa9b9f9a1950825cdac
GIT binary patch
diff --git a/static/region-reunion/style.scss b/static/region-reunion/style.scss
new file mode 100644
index 00000000..67583078
--- /dev/null
+++ b/static/region-reunion/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+@import '../includes/font-source-sans-pro.scss';
+
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.20.1